/*
POS API

No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package posapi

import (
	"encoding/json"
	"time"
)

// checks if the AnybillConfiguration type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AnybillConfiguration{}

// AnybillConfiguration struct for AnybillConfiguration
type AnybillConfiguration struct {
	Id string `json:"id"`
	OrganizationId string `json:"organization_id"`
	ClientId string `json:"client_id"`
	Username string `json:"username"`
	ApiUrl string `json:"api_url"`
	TokenUrl string `json:"token_url"`
	CreatedAt time.Time `json:"created_at"`
	UpdatedAt time.Time `json:"updated_at"`
}

// NewAnybillConfiguration instantiates a new AnybillConfiguration object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAnybillConfiguration(id string, organizationId string, clientId string, username string, apiUrl string, tokenUrl string, createdAt time.Time, updatedAt time.Time) *AnybillConfiguration {
	this := AnybillConfiguration{}
	this.Id = id
	this.OrganizationId = organizationId
	this.ClientId = clientId
	this.Username = username
	this.ApiUrl = apiUrl
	this.TokenUrl = tokenUrl
	this.CreatedAt = createdAt
	this.UpdatedAt = updatedAt
	return &this
}

// NewAnybillConfigurationWithDefaults instantiates a new AnybillConfiguration object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAnybillConfigurationWithDefaults() *AnybillConfiguration {
	this := AnybillConfiguration{}
	return &this
}

// GetId returns the Id field value
func (o *AnybillConfiguration) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *AnybillConfiguration) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *AnybillConfiguration) SetId(v string) {
	o.Id = v
}

// GetOrganizationId returns the OrganizationId field value
func (o *AnybillConfiguration) GetOrganizationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OrganizationId
}

// GetOrganizationIdOk returns a tuple with the OrganizationId field value
// and a boolean to check if the value has been set.
func (o *AnybillConfiguration) GetOrganizationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OrganizationId, true
}

// SetOrganizationId sets field value
func (o *AnybillConfiguration) SetOrganizationId(v string) {
	o.OrganizationId = v
}

// GetClientId returns the ClientId field value
func (o *AnybillConfiguration) GetClientId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ClientId
}

// GetClientIdOk returns a tuple with the ClientId field value
// and a boolean to check if the value has been set.
func (o *AnybillConfiguration) GetClientIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ClientId, true
}

// SetClientId sets field value
func (o *AnybillConfiguration) SetClientId(v string) {
	o.ClientId = v
}

// GetUsername returns the Username field value
func (o *AnybillConfiguration) GetUsername() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Username
}

// GetUsernameOk returns a tuple with the Username field value
// and a boolean to check if the value has been set.
func (o *AnybillConfiguration) GetUsernameOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Username, true
}

// SetUsername sets field value
func (o *AnybillConfiguration) SetUsername(v string) {
	o.Username = v
}

// GetApiUrl returns the ApiUrl field value
func (o *AnybillConfiguration) GetApiUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ApiUrl
}

// GetApiUrlOk returns a tuple with the ApiUrl field value
// and a boolean to check if the value has been set.
func (o *AnybillConfiguration) GetApiUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ApiUrl, true
}

// SetApiUrl sets field value
func (o *AnybillConfiguration) SetApiUrl(v string) {
	o.ApiUrl = v
}

// GetTokenUrl returns the TokenUrl field value
func (o *AnybillConfiguration) GetTokenUrl() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TokenUrl
}

// GetTokenUrlOk returns a tuple with the TokenUrl field value
// and a boolean to check if the value has been set.
func (o *AnybillConfiguration) GetTokenUrlOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TokenUrl, true
}

// SetTokenUrl sets field value
func (o *AnybillConfiguration) SetTokenUrl(v string) {
	o.TokenUrl = v
}

// GetCreatedAt returns the CreatedAt field value
func (o *AnybillConfiguration) GetCreatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.CreatedAt
}

// GetCreatedAtOk returns a tuple with the CreatedAt field value
// and a boolean to check if the value has been set.
func (o *AnybillConfiguration) GetCreatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.CreatedAt, true
}

// SetCreatedAt sets field value
func (o *AnybillConfiguration) SetCreatedAt(v time.Time) {
	o.CreatedAt = v
}

// GetUpdatedAt returns the UpdatedAt field value
func (o *AnybillConfiguration) GetUpdatedAt() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.UpdatedAt
}

// GetUpdatedAtOk returns a tuple with the UpdatedAt field value
// and a boolean to check if the value has been set.
func (o *AnybillConfiguration) GetUpdatedAtOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.UpdatedAt, true
}

// SetUpdatedAt sets field value
func (o *AnybillConfiguration) SetUpdatedAt(v time.Time) {
	o.UpdatedAt = v
}

func (o AnybillConfiguration) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AnybillConfiguration) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["organization_id"] = o.OrganizationId
	toSerialize["client_id"] = o.ClientId
	toSerialize["username"] = o.Username
	toSerialize["api_url"] = o.ApiUrl
	toSerialize["token_url"] = o.TokenUrl
	toSerialize["created_at"] = o.CreatedAt
	toSerialize["updated_at"] = o.UpdatedAt
	return toSerialize, nil
}

type NullableAnybillConfiguration struct {
	value *AnybillConfiguration
	isSet bool
}

func (v NullableAnybillConfiguration) Get() *AnybillConfiguration {
	return v.value
}

func (v *NullableAnybillConfiguration) Set(val *AnybillConfiguration) {
	v.value = val
	v.isSet = true
}

func (v NullableAnybillConfiguration) IsSet() bool {
	return v.isSet
}

func (v *NullableAnybillConfiguration) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAnybillConfiguration(val *AnybillConfiguration) *NullableAnybillConfiguration {
	return &NullableAnybillConfiguration{value: val, isSet: true}
}

func (v NullableAnybillConfiguration) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAnybillConfiguration) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


